// ਬ ᨭ (筥, ⨭)

#include <math.h>  //  sqrt()
#include <stdio.h> //  ࠡ  䠩
#include "video.h"

// ।塞 ⨯ "32-⭮ 楫 ᫮"  ᨬ  

#ifdef __WATCOMC__
typedef int int32;
#endif

#ifdef __BORLANDC__
typedef long int32;
#endif

// 3D-
typedef struct {
  float x, y, z;
} vector;

// RGB-梥
typedef struct {
  float r, g, b;
} color;

// 
typedef struct {
  vector center;     // 業
  color  col;        // 梥
  float  radius;     // ࠤ
  float  kd, ks, ns; // ࠪ⨪ 孮
} sphere;

// 筨 ᢥ
typedef struct {
  vector where; // ⮯
  color  col;   // 梥
} light;

#define NUMSPHERES 3        // ᫮ 
#define NUMLIGHTS  3        // ᫮ 筨 ᢥ
#define INFINITY   1000000L // 筮 讥 ᫮
#define EPSILON    0.001    // 筮 쪮 ᫮

color ambient = {0.3, 0.2, 0.1}; // 䮭 ᢥ饭

//  , ⠢騥 業
sphere spheres[NUMSPHERES] = {
  { {  0,  0,    0}, {1, 1, 1}, 64, 0.7, 0.5, 4 },
  { { 10, 65,  -60}, {1, 1, 1}, 30, 0.8, 0.7, 2 },
  { {-40, 55, -100}, {1, 1, 1},  8, 0.6, 0.3, 3 }
};

//  筨 ᢥ
light lights[NUMLIGHTS] = {
  { { 10,  100, -120}, {0, 1, 0} },
  { {200,    0,    0}, {1, 0, 0} },
  { {-50,   50, -120}, {0, 0, 1} }
};

//  TGA-䠩
char header[12] = {0, 0, 2, 0, 0, 0, 0, 0, 0, 0, 0};

// ᪠୮ ந ஢
float dot(vector a, vector b) {
  return (a.x * b.x + a.y * b.y + a.z * b.z);
}

// ᨬ   ᥫ
float fmax(float a, float b) {
  return (a > b) ? a : b;
}

// ᨭ 㣫  ࠬ  , ᫨ 㣮  90 ࠤᮢ
float vcos(vector a, vector b) {
  return fmax(dot(a, b), 0) / sqrt(dot(a, a) * dot(b, b));
}

//   ஢, linear = ka * a + kb * b
vector linear(vector a, vector b, float ka, float kb) {
  vector res;

  res.x = a.x * ka + b.x * kb;
  res.y = a.y * ka + b.y * kb;
  res.z = a.z * ka + b.z * kb;
  return res;
}

// ਢ   筮
void normalize(vector *a) {
  float l = sqrt(dot(*a, *a));

  a->x /= l;
  a->y /= l;
  a->z /= l;
}

//  祭    (o + k * t), k > 0, 頥 k,  砥
// ⢨ 祭 頥 INFINITY
float isectSphere(vector o, vector t, sphere s) {
  float a, b, c, d, t1, t2;
  vector m;

  // 窠 祭    ,   ; ⠪ ࠧ,
  //  ࠢ
  //
  //     length((o + k * t) - s.center) = radius,
  //
  //  length -  , ⭮,  length(a) = sqrt(dot(a,a)).
  //  ᫥ ८ࠧ 砥 ⭮ ࠢ ⭮⥫쭮
  // k, (a*k*k + b*k + c) = 0  ਬ⮬ d.
  m = linear(o, s.center, 1, -1);
  a = dot(t, t);
  b = 2 * dot(m, t);
  c = dot(m, m) - s.radius * s.radius;
  d = b * b - 4 * a * c;

  // ᫨ ୥ ,   祭 
  if (d < 0) return INFINITY;

  // 饬 ୨
  d = sqrt(d);
  t1 = (-b - d) / (2 * a);
  t2 = (-b + d) / (2 * a);

  // ᫨ 訩 ७ ⥫,   ⥫  k > 0 
  if (t2 < 0) return INFINITY;

  // ᫨ 訩 ७ ⥫,      k. ᫨ ,
  //  ⠥ ⮫쪮 訩 ( 㦥  ⥫).
  if (t1 >= 0) return t1;
  return t2;
}

//  "襣" 祭   業, 頥  ꥪ, 
//  ᥪ ,  -1, ᫨ 祭 . 窠 o  
//  - ꥪ,   㤥   祭.
int isectAll(vector o, vector t, float *k) {
  int    i, closest = -1;
  float  tmpf;

  *k = INFINITY;
  for (i = 0; i < NUMSPHERES; i++) {
    tmpf = isectSphere(o, t, spheres[i]);
    // ᫨ 祭  । ꥪ⮬ 室 , 祬 ⥪饥,
    //   
    if (*k > tmpf && tmpf > EPSILON) {
      closest = i;
      *k = tmpf;
    }
  }
  return closest;
}

// ᮡ⢥ ஢ 祩. 頥 ᢥ饭, 室 
//  o  ࠢ t -  ,   (o + k * t), k > 0.
color trace(vector o, vector t) {
  color  res = {0, 0, 0}, tmpc;
  vector p, n, l, r;
  float  k, tmpf;
  int    i, closest;
  sphere sp;

  // 饬 祭   業
  closest = isectAll(o, t, &k);

  //  祭,   ᢥ饭
  if (closest == -1) return res;

  // sp - ꥪ,   ᥪ  
  sp = spheres[closest];

  // ⠥ p  n,  祭  ଠ  ꥪ  ⮩ 窥
  p = linear(o, t, 1, k);
  n = linear(p, sp.center, 1, -1);
  normalize(&n);

  // 稭  ᢥ饭, ࢮ ᫠: intensity = Ka
  res = ambient;

  //    筨 ᢥ ਬ塞 ࠢ 
  for (i = 0; i < NUMLIGHTS; i++) {
    // l - , ஢  窨  筨 ᢥ
    l = linear(lights[i].where, p, 1, -1);

    // ᫨   窨 p  ࠢ l  ᥪ  業,
    //  窠 p "" 筨 ᢥ, ⠥ ᢥ饭
    if (isectAll(p, l, &tmpf) == -1) {

      // 㧭 (ﭭ ), intensity += kd * cos(n, l)
      tmpf = vcos(n, l) * sp.kd;
      res.r += lights[i].col.r * tmpf;
      res.g += lights[i].col.g * tmpf;
      res.b += lights[i].col.b * tmpf;

      // ࠦ , ⡫; intensity += ks * pow(cos(r, v), ns)
      //  r - ᨬ l ⭮⥫쭮 n , v -   窨 p
      //  ࠢ ; ⠪ ࠧ,  襬 砥 v = t.
      r = linear(n, l, -2 * dot(n, l), 1);
      tmpf = pow(vcos(r, t), sp.ns) * sp.ks;
      res.r += lights[i].col.r * tmpf;
      res.g += lights[i].col.g * tmpf;
      res.b += lights[i].col.b * tmpf;
    }
  }

  // 祭 ᢥ饭 ⠫   梥 ꥪ
  res.r *= sp.col.r;
  res.g *= sp.col.g;
  res.b *= sp.col.b;

  return res;
}

// 㭪 㯠   color   32- ᥫ
int32 packColor(color c) {
  int32 r = (int)(((c.r > 1) ? 1 : c.r) * 255);
  int32 g = (int)(((c.g > 1) ? 1 : c.g) * 255);
  int32 b = (int)(((c.b > 1) ? 1 : c.b) * 255);

  return (b + (g << 8) + (r << 16));
}

void main() {
  int    i, j, k;
  int32  c;
  vector o, t;
  FILE   *f;
  char   *dest;

  // ᮧ traced.tga, 襬 㤠 
  f = fopen("traced.tga", "wb+");
  fwrite(&header, 1, sizeof(header), f);
  i = XSIZE; // ࠧ ⨭  x
  j = YSIZE; // ࠧ ⨭  y
  fwrite(&i, 1, 2, f);
  fwrite(&j, 1, 2, f);
  i = 24;    // ⭮ 梥
  fwrite(&i, 1, 2, f);

  // 樠㥬 ⥬
  initVideo();

  // ⠢   ।⥫쭮 ᬮ (砥   RGB332)
  outp(0x3C8, 0x00);
  for (i = 0; i < 8; i++) {
    for (j = 0; j < 8; j++) {
      for (k = 0; k < 4; k++) {
	outp(0x3C9, i << 3);
	outp(0x3C9, j << 3);
	outp(0x3C9, k << 4);
      }
    }
  }

  // 㥬  ᥫ 筮 ᭨  (⠪   TGA-䠩
  // ப   ࠧ ᭨ )
  for (j = YSIZE - 1; j >= 0; j--) {
    dest = videoMem + j * XSIZE;
    for (i = 0; i < XSIZE; i++) {
      // 窠 o - ,   砫 , (0,0,-DIST)
      o.x = o.y = 0;
      o.z = -DIST;

      // t - ࠢ 
      t.x = i - (XSIZE / 2);
      t.y = (YSIZE / 2) - j;
      t.z = DIST;

      // 㥬 
      c = packColor(trace(o, t));

      // 뢮  ࠭ ॢ  RGB332 梥
      *dest++ = ((c >> 6) & 0x03) + ((c >> 11) & 0x1C) + ((c >> 16) & 0xE0);

      // 襬 । ᥫ  䠩
      fwrite(&c, 1, 3, f);
    }
  }

  fclose(f);   // 뢠 䠩
  getch();     //   
  doneVideo(); // 頥  ⥪⮢ ०
}